#include <LiquidCrystalRus.h>

#define 0 INTER

int pin = 13, imp=0, rnd=0, i=0, d=0;
long time, time_old=0, time_ecspo=600000, tmp, tmas[10]; //время экспозиции среднаго в милисикундах
int mint=time_ecspo/60000;
float imp_pr_60ms=0.00015; //кофициэнт прерсчёта для кол импульсов в 600мс
float mkr=0, smkr=0, mkr_now=0, mkr_nows=0, imptscspo=(time_ecspo/60)*imp_pr_60ms;
float mkr_sn[10]; //временная переменная для усреднения

volatile int state = LOW;
const int analogInPin = A0;
LiquidCrystalRus lcd(12, 10, 11, 5, 4, 3, 2);

void setup()
{
  pinMode(pin, OUTPUT);
  Serial.begin(9600);
  lcd.begin(16, 2);
  time = millis();
  Serial.println("Запуск измерения...");
  lcd.print("Запуск измерения...");
  attachInterrupt(INTER, imp, RISING);
}
 
void loop()
{ 
  if(millis() - time > time_ecspo) {
   detachInterrupt(INTER);
   Serial.print("imp: ");
   Serial.println(imp);
   mkr=imp/imptscspo;
   print_lcddata();
   imp=0;
   Serial.print("mkr/h:");
   Serial.println(mkr);
   time = millis();
   attachInterrupt(INTER, imp, RISING);
  }
}
 
void print_lcddata() {
   lcd.setCursor(0, 0);
   lcd.print("И:");
   lcd.print(imp);
   lcd.print("     ");
   lcd.setCursor(5, 0);
   lcd.print(mkr);
   lcd.print("     ");  
   lcd.print(smkr); 
   lcd.setCursor(0, 1);
   lcd.print("Т:");  
   lcd.print(mkr_now);
   lcd.print("    ");  
   lcd.print("С:");  
   lcd.print(mkr_nows);
   lcd.print("    ");
   Serial.print("Tmkr/h:");
   Serial.println(mkr_now);
}

/*void blink()
{
  //detachInterrupt(0);
  tmp=millis()-time_old;
  tmas[i]=tmp;
  i++;
  if(i>=10) {i=0;  }
  time_old=millis();
  mkr_now=1/((tmp/60)*imp_pr_60ms);
  digitalWrite(pin, 1);
  delay(60);
  if(i==1 || i==4 || i==8 || i==10) { sred();}
  imp=imp+1;
  print_lcddata();
  digitalWrite(pin, 0);
  //attachInterrupt(0, blink, RISING);
}*/

void imp() {
  //detachInterrupt(INTER);
  tmp=millis()-time_old;
  tmas[i]=tmp;
  i++;
  if(i>=10) {i=0;  }
  //attachInterrupt(INTER, imp, RISING);
}

void sred()
{
   //detachInterrupt(0);
   tmp=0;
   for(d=0;d<10;d++) {
    tmp=tmp+tmas[d]; 
   }
   smkr=10/((tmp/60)*imp_pr_60ms);
   Serial.print("Smkr/h:");
   Serial.println(smkr);
   //attachInterrupt(0, blink, RISING);
   
}
